var itemGridManager,dutyPersonGridManager = null
$(function () {
    initItemGrid();
    initDutyPersonGridGrid();
    bindEvent();
});

function bindEvent() {

}

function initItemGrid() {
    var toolbarOptions = UICtrl.getDefaultToolbarOptions({
        addHandler: function(){
            UICtrl.addGridRow(itemGridManager);
        },
        deleteHandler: function (){
            var _grid = UICtrl.getGridManager('#maingrid');
            DataUtil.delSelectedRows({
                action: 'exceptionReport/deleteExceptionReport.ajax',
                param: {},
                gridManager: _grid,
                idFieldName: 'id',
                onSuccess: function () {
                    reloadGrid();
                }
            });
        },
    });
        itemGridManager = UICtrl.grid('#maingrid', {
            columns: getGridColumns(),
            dataAction: 'server',
            url: web_app.name + '/exceptionReport/slicedExceptionReportItemList.ajax',
            parms:{exceptionReportId:getId()},
            height: '300px',
            heightDiff: -4,
            sortName: 'id',
            sortOrder: 'asc',
            checkbox: true,
            usePager: true,
            rownumbers: true,
            enabledEdit: true,
            fixedCellHeight: true,
            selectRowButtonOnly: true,
            //autoApplyNextEditor:false,
            toolbar: toolbarOptions,
        }
    );
    UICtrl.setSearchAreaToggle(itemGridManager);
}

function getGridColumns() {
    var columns = [];
    columns = [
        {display: "生产单号", name: "produceNo", width: "200", align: "left", type: "string",
            editor: { type: 'text'}
        },
        {display: "产品编码", name: "productCode", width: "200", align: "left", type: "string",
            editor: {type: 'text'}
        },
        {display: "产品名称", name: "productName", width: "200", align: "left", type: "string",
            editor: {type: 'text'}
        },
        {display: "数量", name: "number", width: "100", align: "left", type: "string",
            editor: {type: "text",mask: '9999999.999'}
        },
        {display: "单位", name: "unitName", width: "100", align: "left", type: "string",
            editor: {type: "text"}
        },
        {display: "币别", name: "currencyName", width: "100", align: "left", type: "string",
            editor: {type: "text"}
        },
        {display: "金额", name: "money", width: "100", align: "left", type: "string",
            editor: {type: "text",mask: '9999999.999'}
        },
        {display: "转换成人民币金额", name: "rmbMoney", width: "100", align: "left", type: "string",
            editor: {type: "text",mask: '9999999.999'}
        },
        {display: "出货日期", name: "sendDate", width: "200", align: "left", type: "date",
            editor: {type: "date"}
        }
    ]
    return columns;
}

function initDutyPersonGridGrid() {
    var toolbarOptions = UICtrl.getDefaultToolbarOptions({
        addHandler: function(){
            UICtrl.addGridRow(dutyPersonGridManager);
        },
        deleteHandler: function (){
            var _grid = UICtrl.getGridManager('#dutyPersonGrid');
            DataUtil.delSelectedRows({
                action: 'exceptionReport/deleteExceptionReportDutyPerson.ajax',
                param: {},
                gridManager: _grid,
                idFieldName: 'id',
                onSuccess: function () {
                    reloadGrid();
                }
            });
        },
    });
    dutyPersonGridManager = UICtrl.grid('#dutyPersonGrid', {
            columns: getDutyPersonGridColumns(),
            dataAction: 'server',
            url: web_app.name + '/exceptionReport/slicedExceptionReportDutyPersonList.ajax',
            parms:{exceptionReportId:getId()},
            height: '300px',
            heightDiff: -4,
            sortName: 'id',
            sortOrder: 'asc',
            checkbox: true,
            usePager: true,
            rownumbers: true,
            enabledEdit: true,
            fixedCellHeight: true,
            selectRowButtonOnly: true,
            //autoApplyNextEditor:false,
            toolbar: toolbarOptions,
        }
    );
    UICtrl.setSearchAreaToggle(dutyPersonGridManager);
}

function getDutyPersonGridColumns() {
    var columns = [];
    columns = [
        {display: "工号/供应商编码/客户名编码", name: "personNo", width: "200", align: "left", type: "string",
            editor: { type: 'text'}
        },
        {display: "姓名/供应商名称/客户名", name: "personName", width: "200", align: "left", type: "string",
            editor: {type: 'text'}
        },
        {display: "部门/供应名称/客户名称", name: "deptName", width: "200", align: "left", type: "string",
            editor: {type: 'text'}
        },
        {display: "定责比例（%）", name: "dutyRate", width: "100", align: "left", type: "string",
            editor: {type: "text",mask: '999.99'}
        },
        {display: "个人责任比例（%）", name: "personDutyRate", width: "200", align: "left", type: "string",
            editor: {type: "text",mask: '999.99'}
        },
        {display: "责任金额", name: "dutyMoney", width: "100", align: "left", type: "string",
            editor: {type: "text",mask: '9999999.999'}
        },
        {display: "备注", name: "remark", width: "300", align: "left", type: "string",
            editor: {type: "text"}
        },
    ]
    return columns;
}

//获取数据保存的参数
function getExtendedData(processAction) {
    //回退、打回、转交时，不需要验证必填项是否已经填写；
    if (processAction == ProcessAction.BACK
        || processAction == ProcessAction.REPLENISH
        || processAction == ProcessAction.TRANSMIT) {
        //不验证
        $('#submitForm').attr('check', false);
    }
    var extendedData = {};
    var _grid = UICtrl.getGridManager('#maingrid');
    if (_grid) {
        var datas = DataUtil.getGridData({
            gridManager: _grid,
            isAllData: true
        });
        if (!datas) {
            return false;
        }
        extendedData.exceptionReportItems = Public.encodeJSONURI(datas);
    }

    var _dutyPersonGrid = UICtrl.getGridManager('#dutyPersonGrid');
    if (_dutyPersonGrid) {
        var datas = DataUtil.getGridData({
            gridManager: _dutyPersonGrid,
            isAllData: true
        });
        if (!datas) {
            return false;
        }
        extendedData.personList = Public.encodeJSONURI(datas);
    }
    return extendedData;
}

function getId() {
    return $('#id').val();
}

function setId(value) {
    $("#id").val(value);
    var _grid=UICtrl.getGridManager('#maingrid');
    _grid.options.parms.exceptionReportId = value;

    var _dutyPersonGrid=UICtrl.getGridManager('#dutyPersonGrid');
    _dutyPersonGrid.options.parms.exceptionReportId = value;
}

function reloadGrid() {
    itemGridManager.loadData();
    dutyPersonGridManager.loadData();
}

