var itemGridManager = null,fillinDate="";
$(function () {
    initItemGrid();
    bindEvent();
});

function bindEvent() {
    fillinDate = $("#fillinDate").val();
}

function initItemGrid() {
    var toolbarOptions = UICtrl.getDefaultToolbarOptions({
        addHandler: function(){
            UICtrl.addGridRow(itemGridManager);
        },
        deleteHandler: function (){
            var _grid = UICtrl.getGridManager('#maingrid');
            DataUtil.delSelectedRows({
                action: 'sapPurchaseInfoRecordItem/deleteSapPurchaseInfoRecordItem.ajax',
                param: {},
                gridManager: _grid,
                idFieldName: 'id',
                onSuccess: function () {
                    reloadGrid();
                }
            });
        },
    });
        itemGridManager = UICtrl.grid('#maingrid', {
            columns: getGridColumns(),
            dataAction: 'server',
            url: web_app.name + '/sapPurchaseInfoRecordItem/querySapPurchaseInfoRecordItems.ajax',
            parms:{sapPurchaseInfoRecordId:getId()},
            height: '99.6%',
            heightDiff: -4,
            sortName: 'id',
            sortOrder: 'asc',
            checkbox: true,
            usePager: true,
            rownumbers: true,
            enabledEdit: true,
            fixedCellHeight: true,
            selectRowButtonOnly: true,
            //autoApplyNextEditor:false,
            toolbar: toolbarOptions,
            onBeforeEdit: function (editParma) {
                if (Public.isNotBlank(editParma.record.matnr) && editParma.column.name=='matklName'){
                    return false;
                }
                if (Public.isNotBlank(editParma.record.matklName) && Public.isBlank(editParma.record.maktx) && editParma.column.name=='matnr'){
                    return false;
                }

                return true;

            },
        }
    );
    UICtrl.setSearchAreaToggle(itemGridManager);
}

function getGridColumns() {
    var columns = [];
    columns = [
        // {display: "语言", name: "zyy", width: "80", align: "left", type: "string",
        //     editor: {required: false, type: "text"}
        // },
        {display: "采购信息记录号", name: "infnr", width: "100", align: "left", type: "string",
            //editor: {required: false, type: "text"}
        },
        {display: "工厂", name: "werksName", width: "200", align: "left", type: "string",
            editor: {
                required: true, type: "select",
                data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {fieldName: "WERKS"}
                    },
                    back: {
                        WERKS: "werks",
                        NAME1: "werksName",
                    }
                },
            }
        },
        {display: "采购组织", name: "ekorgName", width: "200", align: "left", type: "string",
            editor: {
                required: true, type: "select",
                data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {
                            fieldName: "EKORG",
                            filterValue:item.werks
                        }
                    },
                    back: {
                        EKORG: "ekorg",
                        EKOTX: "ekorgName",
                    }
                },
            }
        },
        {display: "供应商", name: "lifnr", width: "200", align: "left", type: "string",
            editor: {required: true, type: "text"}
            // editor: {
            //     required: true, type: "select",
            //     data: {
            //         type: 'system',
            //         name: "dictionary",
            //         getParam: function (item) {
            //             return {fieldName: "LIFNR"}
            //         },
            //         back: {
            //             LIFNR: "lifnr",
            //             NAME1: "lifnrName",
            //         }
            //     },
            // }
        },
        {display: "供应商物料编码", name: "idnlf", width: "100", align: "left", type: "string",
            editor: {required: false, type: "text"}
        },
        {display: "名称1", name: "name1", width: "100", align: "left", type: "string",
            editor: {required: false, type: "text"}
        },
        {display: "物料编码", name: "matnr", width: "200", align: "left", type: "string",
            editor: {
                required: true, type: "select",
                data: {
                    type: 'system',
                    name: "sapMaterialSelect",
                    getParam: function (item) {
                        return {
                            filterValue:item.werks
                        }
                    },
                    back: {
                        MATNR: "matnr",
                        MAKTX: "maktx",
                        MATKL: "matkl",
                        WGBEZ: "matklName",
                        EKGRP: "ekgrp",
                        EKNAM: "ekgrpName",
                        PEINH: "peinh",
                        MEINS: "meins",
                        MSEHL:"meinsName",
                        MEINS:"bprme",
                        MSEHL:"bprmeName",
                    }
                },
            }
        },
        {display: "物料描述", name: "maktx", width: "200", align: "left", type: "string",
            editor: {required: true, type: "text"}
        },
        {display: "物料组", name: "matklName", width: "200", align: "left", type: "string",
            editor: {
                required: true, type: "select",
                data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {
                            fieldName: "MATKL"
                        }
                    },
                    back: {
                        MATKL: "matkl",
                        WGBEZ: "matklName",
                    }
                },
            }
        },
        {display: "采购信息记录分类", name: "esokzTextView", width: "200", align: "left", type: "string",
            editor: {
                type: 'dictionary',
                data: {name: 'esokz'},
                textField: 'esokzTextView',
                valueField: 'esokz',
                required: true,
                render: function (item) {
                    return item.esokzTextView;
                }
            },
        },
        {display: "采购组", name: "ekgrpName", width: "200", align: "left", type: "string",
            editor: {
                required: true, type: "select",
                data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {fieldName: "EKGRP"}
                    },
                    back: {
                        EKGRP: "ekgrp",
                        EKNAM: "ekgrpName"
                    }
                },
            }
        },
        {display: "生产版本", name: "verid", width: "200", align: "left", type: "string",
            editor: {required: false, type: "text"}
        },
        {display: "净价", name: "netpr", width: "100", align: "left", type: "string",
            editor: {type: 'text', mask: '9999999.99'}
        },
        {display: "货币码", name: "waers", width: "100", align: "left", type: "string",
            // editor: {
            //     required: true, type: "select",
            //     data: {
            //         type: 'system',
            //         name: "dictionary",
            //         getParam: function (item) {
            //             return {fieldName: "WAERS"}
            //         },
            //         back: {
            //             WAERS: "waers",
            //             EKGRP: "waersName"
            //         }
            //     },
            // }
            editor: {required: false, type: "text"}
        },
        {display: "价格单位", name: "peinh", width: "100", align: "left", type: "string",
            editor: {required: false, type: "text"}
        },
        {display: "订单价格单位(采购)", name: "bprmeName", width: "90", align: "left", type: "string",
            editor: {
                required: false, type: "select",
                data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {fieldName: "MEINS"}
                    },
                    back: {
                        MSEHI: "bprme",
                        MSEHL: "bprmeName",
                    }
                },
            }
        },
        {display: "基本计量单位", name: "meinsName", width: "100", align: "left", type: "string",
            editor: {
                required: true, type: "select",
                data: {
                    type: 'system',
                    name: "dictionary",
                    getParam: function (item) {
                        return {fieldName: "MEINS"}
                    },
                    back: {
                        MSEHI: "meins",
                        MSEHL: "meinsName",
                    }
                },
            }
        },
        {display: "单位转换分母", name: "umren", width: "100", align: "left", type: "string",
            editor: {type: 'text', mask: '9999999.99'}
        },
        {display: "单位转换分子", name: "umrez", width: "100", align: "left", type: "string",
            editor: {type: 'text', mask: '9999999.99'}
        },
        {display: "销售/购买税代码", name: "mwskz", width: "100", align: "left", type: "string",
            editor: {type: "text", required: false,}
        },
        {display: "开始生效日期", name: "datab", width: "100", align: "left", type: "string",
            editor: {type: 'date'},
        },
        {display: "有效期至日期", name: "datbi", width: "100", align: "left", type: "string",
            editor: {type: 'date'},
        },
        {display: "等级数量", name: "kstbm", width: "100", align: "left", type: "string",
            editor: {type: 'text', mask: '9999999.99'}
        },
        {display: "销售员", name: "verkf", width: "100", align: "left", type: "string",
            editor: {required: false, type: "text"}
        },
        {display: "电话", name: "telf1", width: "100", align: "left", type: "string",
            editor: {required: false, type: "text"}
        },

        {display: "原产地国", name: "urzla", width: 150, minWidth: 60, type: "string", align: "center",
            editor: {required: false, type: "text"}
        },
        {display: "地区", name: "regio", width: 150, minWidth: 60, type: "string", align: "center",
            editor: {required: false, type: "text"}
        },
        {display: "删除标志", name: "loekzTextView", width: 150, minWidth: 60, type: "string", align: "center",
            editor: {
                type: 'dictionary',
                data: {name: 'loekz'},
                textField: 'loekzTextView',
                valueField: 'loekz',
                required: false,
                render: function (item) {
                    return item.loekzTextView;
                }
            },
        },
        {display: "排序字段", name: "sortl", width: 150, minWidth: 60, type: "string", align: "center",
            editor: {required: false, type: "text"}
        },
        {display: "标准采购订单数量", name: "norbm", width: "120", align: "left", type: "string",
            editor: {type: 'text', mask: '9999999.99'}
        },
        {display: "最小采购订单数量", name: "minbm", width: "120", align: "left", type: "string",
            editor: {type: 'text', mask: '9999999.99'}
        },
        {display: "等级类型", name:"stfkzTextView", width: "200", align: "left", type: "string",
            editor: {
                type: 'dictionary',
                data: {name: 'stfkz'},
                textField: 'stfkzTextView',
                valueField: 'stfkz',
                required: true,
                render: function (item) {
                    return item.stfkzTextView;
                }
            },
        },
        {display: "计划交货时间(天)", name: "aplfz", width: "150", align: "left", type: "string",
            editor: {type: 'text', mask: '9999999.99'}
        },




        {display: "业务标识", name: "zflag", width: 150, minWidth: 60, type: "string", align: "center",
            editor: {required: false, type: "text"}
        },
        {display: '基于收货的发票验证', name: "webre", width: "100", align: "left", type: "string",
            editor: {required: false, type: "text"}
        },
        {display: "条件类型", name: "kschl", width: "100", align: "left", type: "string",
            editor: {type: 'text', required: false}
        },
        {display: "价格有效至", name: "prdat", width: "100", align: "left", type: "string",
            editor: {type: 'date', required: false}
        },
        {display: "订单价格单位转换为订单单位的分母", name: "bpumn", width: "100", align: "left", type: "string",
            editor: {type: 'text', mask: '9999999.99'}
        },
        {display: "订单价格单位转换为订单单位的分子", name: "bpumz", width: "100", align: "left", type: "string",
            editor: {type: 'text', mask: '9999999.99'}
        },
        {display: "条件等级计量单位", name: "konms", width: "100", align: "left", type: "string",
            editor: {type: 'text'}
        },
        {display: "价格", name: "kbetr", width: "100", align: "left", type: "string",
            editor: {type: 'text', mask: '9999999.99'}
        },
        {
            display: "传输日期", name: "sendTime", width: "100", align: "left", type: "string",
            editor: {type: 'date'}
        }
    ]
    return columns;
}

//获取数据保存的参数
function getExtendedData(processAction) {
    //回退、打回、转交时，不需要验证必填项是否已经填写；
    if (processAction == ProcessAction.BACK
        || processAction == ProcessAction.REPLENISH
        || processAction == ProcessAction.TRANSMIT) {
        //不验证
        $('#submitForm').attr('check', false);
    }
    var extendedData = {};
    var _grid = UICtrl.getGridManager('#maingrid');
    if (_grid) {
        var datas = DataUtil.getGridData({
            gridManager: _grid,
            isAllData: true
        });
        if (!datas) {
            return false;
        }
        datas.forEach(data=>{
            if (Public.isNotBlank(data.bprme)
                && Public.isNotBlank(data.meins)
                && (Public.isBlank(data.umren) || Public.isBlank(data.umrez))){
                Public.tip("订单价格单位不为空，单位转换分子、分母必填")
                return false;
            }

        })
        extendedData.sapPurchaseInfoRecordItems = Public.encodeJSONURI(datas);
    }
    return extendedData;
}

function getId() {
    return $('#id').val();
}

function setId(value) {
    $("#id").val(value);
    var _grid=UICtrl.getGridManager('#maingrid');
    _grid.options.parms.sapPurchaseInfoRecordId = value;
}

function reloadGrid() {
    itemGridManager.loadData();
}

function getGridData(){
    var _grid = UICtrl.getGridManager('#maingrid');
    var datas = DataUtil.getGridData({
        gridManager: _grid,
        isAllData: true
    });
    return datas;
}

